<?php
/**
 * @file
 * Field validation custom validator.
 *
 */
$plugin = array(
  'label' => t('(Deprecated)Custom PHP function'),
  'description' => t('(Deprecated)Validate current field using custom PHP function.'),
  'handler' => array(
    'class' => 'field_validation_custom_validator',
  ),
);

class field_validation_custom_validator extends field_validation_validator {

  /**
   * Validate field. 
   */
  public function validate() {
    $flag = TRUE;
    $custom_function_name = $this->rule->settings['data'];
    if (function_exists($custom_function_name)) {
      $flag = $custom_function_name($this);
      if (!$flag) {
        $this->set_error();
      }
    }
  }
  
  /**
   * Provide settings option
   */
  function settings_form(&$form, &$form_state) {
    $default_settings = $this->get_default_settings($form, $form_state);
    //print debug($default_settings);
    $form['settings']['data'] = array(
      '#title' => t('(Deprecated)Function name'),
      '#description' => t('(Deprecated)Specify the custom PHP function name for this field. It contains one argument, variables, for example, mymodule_validate_myfield(variables). Then you could enter its name at here: mymodule_validate_myfield.'),
      '#type' => 'textfield',
      '#default_value' => isset($default_settings['data']) ? $default_settings['data'] : '',
    );
  }

}