<?php
/**
 * @file
 * Field validation custom validator.
 *
 */
$plugin = array(
  'label' => t('(Deprecated)Must match another field'),
  'description' => t('(Deprecated)Validates that user-entered data matches another field or entity property.'),
  'handler' => array(
    'class' => 'field_validation_match_another_field_validator',
  ),
);

class field_validation_match_another_field_validator extends field_validation_validator {

  /**
   * Validate field. 
   */
  public function validate() {
    $arguments = $this->rule->settings['data'];
    $arguments = explode('&', $arguments);
    $arg_array = array();
    //debug($arguments);
    foreach ($arguments as $arg) {
      $argument = explode('=', $arg);
      $name = trim($argument[0]);
      $value = trim($argument[1]);
      $arg_array[$name] = $value;
    }

    if ($this->value != '') { 
      $query = new EntityFieldQuery();
      if (!empty($arg_array['entity_type'])) {
        $query->entityCondition('entity_type', $arg_array['entity_type']);
      }
      if (!empty($arg_array['bundle'])) {
        $query->entityCondition('bundle', $arg_array['bundle']);
      }
      if (!empty($arg_array['is_property'])) {
        if (!empty($arg_array['column'])) {
          $query->propertyCondition($arg_array['column'], $this->value);
        }
      }
      else{
        if (!empty($arg_array['field_name']) && !empty($arg_array['column'])) {
          $query->fieldCondition($arg_array['field_name'], $arg_array['column'], $this->value);
        }
      }
      $flag = (bool)$query->range(0, 1)->count()->execute();
      if (!empty($arg_array['reverse'])) {
        $flag = $flag ? FALSE : TRUE;
      }
      if (!$flag) {
        $this->set_error();
      }
    }
  }
  
  /**
   * Provide settings option
   */
  function settings_form(&$form, &$form_state) {
    $default_settings = $this->get_default_settings($form, $form_state);
    //print debug($default_settings);
    $form['settings']['data'] = array(
      '#title' => t('(Deprecated)Arguments of another field'),
      '#description' => t("(Deprecated)Specify the arguments of another field, support: entity_type, field_name, bundle, column, is_property. for example,entity_type=node&bundle=article&column=title&is_property=TRUE, entity_type=user&column=name&is_property=TRUE."),
      '#type' => 'textfield',
      '#default_value' => isset($default_settings['data']) ? $default_settings['data'] : '',
    );
  }

}