<?php
/**
 * @file
 * Field validation max length validator.
 *
 */
$plugin = array(
  'label' => t('(Deprecated)Maximum length'),
  'description' => t('(Deprecated)Verifies that a user-entered value contains at most the specified number of characters.'),
  'handler' => array(
    'class' => 'field_validation_max_length_validator',
  ),
);

class field_validation_max_length_validator extends field_validation_validator {

  /**
   * Validate field. 
   */
  public function validate() {
    $max_length = $this->rule->settings['data'];
    if ($this->value != '' && (drupal_strlen($this->value) > $max_length)) {
      $this->set_error();
    }
  }
  
  /**
   * Provide settings option
   */
  function settings_form(&$form, &$form_state) {
    $default_settings = $this->get_default_settings($form, $form_state);
    //print debug($default_settings);
    $form['settings']['data'] = array(
      '#title' => t('(Deprecated)Maximum number of characters'),
      '#description' => t("(Deprecated)Specify the maximum number of characters that can be entered to pass validation."),
      '#type' => 'textfield',
      '#default_value' => isset($default_settings['data']) ? $default_settings['data'] : '',
    );
  }

}