<?php
/**
 * @file
 * Field validation max words validator.
 *
 */
$plugin = array(
  'label' => t('(Deprecated)Maximum number of words'),
  'description' => t('(Deprecated)Verifies that a user-entered value contains at most the specified number of words.'),
  'handler' => array(
    'class' => 'field_validation_max_words_validator',
  ),
);

class field_validation_max_words_validator extends field_validation_validator {

  /**
   * Validate field. 
   */
  public function validate() {
    $settings = $this->rule->settings;
    if ($this->value != '') {
      $flag = TRUE;
      $count = count(explode(' ', trim(preg_replace('/\s+/', ' ', str_replace('&nbsp;', ' ', (strip_tags(str_replace('<', ' <', $this->value))))))));
      if (isset($settings['data']) && $settings['data'] != '' && $count > $settings['data']) {
        $flag = FALSE;
      }
      if (!$flag) {
        $this->set_error();
      }
    }
  }
  
  /**
   * Provide settings option
   */
  function settings_form(&$form, &$form_state) {
    $default_settings = $this->get_default_settings($form, $form_state);
    //print debug($default_settings);
    $form['settings']['data'] = array(
      '#title' => t('(Deprecated)Maximum number of words'),
      '#description' => t("(Deprecated)Specify the maximum number of words that have to be entered to pass validation. Words are defined as strings of letters separated by spaces."),
      '#type' => 'textfield',
      '#default_value' => isset($default_settings['data']) ? $default_settings['data'] : '',
    );
  }

}