<?php
/**
 * @file
 * Field validation select min validator.
 *
 */
$plugin = array(
  'label' => t('(Deprecated)Minimum number of selections required'),
  'description' => t('(Deprecated)Forces the user to select at least a defined number of options from the specified list field.'),
  'handler' => array(
    'class' => 'field_validation_select_min_validator',
  ),
);

class field_validation_select_min_validator extends field_validation_validator {

  /**
   * Validate field. 
   */
  public function validate() {
    $settings = $this->rule->settings;
    $total_items = count($this->items);
    $flag = TRUE;

    if (isset($settings['data']) && $settings['data'] != '' && $total_items < $settings['data']) {
      $flag = FALSE;
    }      

    if (!$flag) {
      $this->set_error();
    }
    //Do not need to validate other items.
    $break = TRUE;
    return $break;

  }
  
  /**
   * Provide settings option
   */
  function settings_form(&$form, &$form_state) {
    $default_settings = $this->get_default_settings($form, $form_state);
    //print debug($default_settings);
    $form['settings']['data'] = array(
      '#title' => t('(Deprecated)Minimum number of selections'),
      '#description' => t("(Deprecated)Specify the minimum number of options a user should select."),
      '#type' => 'textfield',
      '#default_value' => isset($default_settings['data']) ? $default_settings['data'] : '',
    );
  }

}